CropImageFilter (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt.image, class: CropImageFilter
Keywords: java.awt.image.CropImageFilter class

# Class CropImageFilter

java.lang.Object
java.awt.image.ImageFilter
java.awt.image.CropImageFilter

All Implemented Interfaces:
  `ImageConsumer, Cloneable`

public class CropImageFilter extends ImageFilter
An ImageFilter class for cropping images. This class extends the basic ImageFilter Class to extract a given rectangular region of an existing Image and provide a source for a new image containing just the extracted region. It is meant to be used in conjunction with a FilteredImageSource object to produce cropped versions of existing images.

See Also:
  - `FilteredImageSource`
  - `ImageFilter`

- ## Field Summary

  ### Fields declared in class ImageFilter

  `consumer`
  Modifier and Type
  Field
  Description
  `protected ImageConsumer`
  `consumer`
  The consumer of the particular image data stream for which this instance of the ImageFilter is filtering data.

  ### Fields declared in interface ImageConsumer

  `COMPLETESCANLINES, IMAGEABORTED, IMAGEERROR, RANDOMPIXELORDER, SINGLEFRAME, SINGLEFRAMEDONE, SINGLEPASS, STATICIMAGEDONE, TOPDOWNLEFTRIGHT`
  Modifier and Type
  Field
  Description
  `static final int`
  `COMPLETESCANLINES`
  The pixels will be delivered in (multiples of) complete scanlines at a time.
  `static final int`
  `IMAGEABORTED`
  The image creation process was deliberately aborted.
  `static final int`
  `IMAGEERROR`
  An error was encountered while producing the image.
  `static final int`
  `RANDOMPIXELORDER`
  The pixels will be delivered in a random order.
  `static final int`
  `SINGLEFRAME`
  The image contain a single static image.
  `static final int`
  `SINGLEFRAMEDONE`
  One frame of the image is complete but there are more frames to be delivered.
  `static final int`
  `SINGLEPASS`
  The pixels will be delivered in a single pass.
  `static final int`
  `STATICIMAGEDONE`
  The image is complete and there are no more pixels or frames to be delivered.
  `static final int`
  `TOPDOWNLEFTRIGHT`
  The pixels will be delivered in top-down, left-to-right order.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CropImageFilter(int x, int y, int w, int h)`
  Constructs a CropImageFilter that extracts the absolute rectangular region of pixels from its source Image as specified by the x, y, w, and h parameters.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setDimensions(int w, int h)`
  Override the source image's dimensions and pass the dimensions of the rectangular cropped region to the ImageConsumer.
  `void`
  `setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)`
  Determine whether the delivered byte pixels intersect the region to be extracted and passes through only that subset of pixels that appear in the output region.
  `void`
  `setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)`
  Determine if the delivered int pixels intersect the region to be extracted and pass through only that subset of pixels that appear in the output region.
  `void`
  `setProperties(Hashtable<?,?> props)`
  Passes along the properties from the source object after adding a property indicating the cropped region.

  ### Methods declared in class ImageFilter

  `clone, getFilterInstance, imageComplete, resendTopDownLeftRight, setColorModel, setHints`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Clones this object.
  `ImageFilter`
  `getFilterInstance(ImageConsumer ic)`
  Returns a unique instance of an ImageFilter object which will actually perform the filtering for the specified ImageConsumer.
  `void`
  `imageComplete(int status)`
  Filters the information provided in the imageComplete method of the ImageConsumer interface.
  `void`
  `resendTopDownLeftRight(ImageProducer ip)`
  Responds to a request for a TopDownLeftRight (TDLR) ordered resend of the pixel data from an `ImageConsumer`.
  `void`
  `setColorModel(ColorModel model)`
  Filter the information provided in the setColorModel method of the ImageConsumer interface.
  `void`
  `setHints(int hints)`
  Filters the information provided in the setHints method of the ImageConsumer interface.

  ### Methods declared in class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CropImageFilter

    public CropImageFilter(int x, int y, int w, int h)
    Constructs a CropImageFilter that extracts the absolute rectangular region of pixels from its source Image as specified by the x, y, w, and h parameters.
    Parameters:
      `x` - the x location of the top of the rectangle to be extracted
      `y` - the y location of the top of the rectangle to be extracted
      `w` - the width of the rectangle to be extracted
      `h` - the height of the rectangle to be extracted

- ## Method Details

  - ### setProperties

    public void setProperties(Hashtable<?,?> props)
    Passes along the properties from the source object after adding a property indicating the cropped region. This method invokes `super.setProperties`, which might result in additional properties being added.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

    Specified by:
      `setProperties` in interface `ImageConsumer`
    Overrides:
      `setProperties` in class `ImageFilter`
    Parameters:
      `props` - the properties from the source object

  - ### setDimensions

    public void setDimensions(int w, int h)
    Override the source image's dimensions and pass the dimensions of the rectangular cropped region to the ImageConsumer.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

    Specified by:
      `setDimensions` in interface `ImageConsumer`
    Overrides:
      `setDimensions` in class `ImageFilter`
    Parameters:
      `w` - the width of the source image
      `h` - the height of the source image
    See Also:
      - `ImageConsumer`

  - ### setPixels

    public void setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)
    Determine whether the delivered byte pixels intersect the region to be extracted and passes through only that subset of pixels that appear in the output region.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

    Specified by:
      `setPixels` in interface `ImageConsumer`
    Overrides:
      `setPixels` in class `ImageFilter`
    Parameters:
      `x` - the X coordinate of the upper-left corner of the area of pixels to be set
      `y` - the Y coordinate of the upper-left corner of the area of pixels to be set
      `w` - the width of the area of pixels
      `h` - the height of the area of pixels
      `model` - the specified `ColorModel`
      `pixels` - the array of pixels
      `off` - the offset into the `pixels` array
      `scansize` - the distance from one row of pixels to the next in the `pixels` array
    See Also:
      - `ImageConsumer.setPixels(int, int, int, int, ColorModel, byte[], int, int)`

  - ### setPixels

    public void setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)
    Determine if the delivered int pixels intersect the region to be extracted and pass through only that subset of pixels that appear in the output region.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

    Specified by:
      `setPixels` in interface `ImageConsumer`
    Overrides:
      `setPixels` in class `ImageFilter`
    Parameters:
      `x` - the X coordinate of the upper-left corner of the area of pixels to be set
      `y` - the Y coordinate of the upper-left corner of the area of pixels to be set
      `w` - the width of the area of pixels
      `h` - the height of the area of pixels
      `model` - the specified `ColorModel`
      `pixels` - the array of pixels
      `off` - the offset into the `pixels` array
      `scansize` - the distance from one row of pixels to the next in the `pixels` array
    See Also:
      - `ImageConsumer.setPixels(int, int, int, int, ColorModel, byte[], int, int)`